Subject: Re: bug#34407: Acknowledgement (Shepherd won't close socket on exit)

From: Maxim Cournoyer <[email-masked]>
Date: Wed, 13 Feb 2019 18:05:11 -0500

Hi,

nly <[email-masked]> writes:

> Looks like I pasted something wrong in the previous message. I realized
> after I saw it on the mail.
>
> This time I've checked it twice. Left the shepherd in a weird limbo
> where connection is refused to the old socket and cannot create new
> connection. 
>
> Ofcourse, i can `rm /run/user/1000/shepherd/socket`
> --------------------------------------------------------------------------------
> nly@uf ~$ herd status
> error: connect: /run/user/1000/shepherd/socket: No such file or directory
> nly@uf ~$ shepherd
> Service root has been started.
> nly@uf ~$ herd status
> Started:
>  + root
> Stopped:
>  - icecat
>  - jack
>  - mpv
>  - mpv-jack
>  - tor
>  - transmission
> nly@uf ~$ herd stop root
> nly@uf ~$ herd status
> error: connect: /run/user/1000/shepherd/socket: Connection refused
> nly@uf ~$ shepherd
> Service root has been started.
> nly@uf ~$ Backtrace:
>            3 (primitive-load "/run/current-system/profile/bin/shepherd")
> In shepherd.scm:
>    250:24  2 (main . _)
>      48:6  1 (open-server-socket _)
> In unknown file:
>            0 (bind #<input-output: socket 13> #(1 "/run/user/1000/shepherd/socket") #)
>
> ERROR: In procedure bind:
> In procedure bind: Address already in use
>   C-c C-c
> nly@uf ~$ herd status
> error: connect: /run/user/1000/shepherd/socket: Connection refused

This has been annoying me as well; my current workaround is to put this
in my ~/.xsession:

--8<---------------cut here---------------start------------->8---
# Start user services
rm -f /run/user/1000/shepherd/socket
shepherd
--8<---------------cut here---------------end--------------->8---

Maxim